# DDL.jl

The *up* function provides the core data base tables for transactions on bitemporal entities.
Applications use calling BitemporalProgress.DDL.up to create these core tables and have to have to provide their own 
schema creation modules to create their component and subcomponent tables along woth their revision tables.

DDL provides test dummies of such tables for CI.

## A remark on serialization of zoned timestamps
Serialization of ZonedDateTimes requires milliseconds to be stored as the default dateformat of ZonedDateTime is "yyyy-mm-ddTHH:MM:SS.ssszzz".
Mapping postgres columns of type **timestamptz** to julia fields of type **ZonedDateTime** leads to parse errors in copying structs using paramterless constructors. 
`ArgumentError: Unable to parse string "2014-05-30T20:00:01+00:00" using format dateformat"yyyy-mm-ddTHH:MM:SS.ssszzz".` 
Therefore this project uses **timestamptz(3)** columns, as in DDL.up(): 
`column(:tsw_validfrom, :timestamptz,"(3)")`



```@docs
up()
down()
```
